//
//  SCIVertex.h
//  ComNetKit
//
//  Created by Filipi Nascimento Silva on 11/5/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <SciObjects/SciObjects.h>
#import <ComNetKit/ComNetKit.h>


@interface SCIEdge : NSObject {
@protected
	SCINetwork* __relatedNetwork; //__weak
	NSUInteger __identification;
	BOOL __networkValidity;
}


-initAtNetwork:(SCINetwork*)relatedNetwork identification:(NSUInteger)identification;


-(NSString*) name;
-(float) weight;
-(NSDictionary*) properties;
-(id)propertyForKey:(id)key;
-(NSUInteger) identification;

-(void)setName:(NSString*)newName;
-(void)setWeight:(float)newWeight;
-(void)setProperties:(NSDictionary*)newProperties;
-(void)setProperty:(id)property forKey:(id)key;

-(NSArray*) keysForProperties;



-(BOOL) blockEditing;
-(BOOL) isEditable;
-(BOOL) isDirected;
-(BOOL) isWeighted;


-(SCIVertex*) fromVertex;
-(SCIVertex*) toVertex;

-(SCIVertex*) vertexFromVertex:(SCIVertex*)fromVertex;
-(SCINetwork*) relatedNetwork;

-(void)invalidateNetwork;
-(BOOL)isValid;

@end
