//
//  SCIBasicNetwork.h
//  ComNetKit
//
//  Created by Filipi Nascimento Silva on 01/29/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SciObjects/SciObjects.h>
#import <ComNetKit/ComNetKit.h>
#define _SCI_DefaultEdgeIncrement 20;
#define _SCI_DefaultEdgeMultiplierIncrement 2;

//basic implementation of SCINetwork using Adjacency Matrix.



@interface SCINetwork : NSObject {
@public
	NSUInteger* __vertexNumOfEdges;
	NSUInteger* __vertexCapacityOfEdges;
	NSUInteger** __vertexEdgesLists;
	NSUInteger** __vertexEdgesIndices;
	
	NSUInteger* __vertexNumOfInEdges;
	NSUInteger* __vertexCapacityOfInEdges;
	NSUInteger** __vertexInEdgesLists;
	NSUInteger** __vertexInEdgesIndices;
	
	NSUInteger* __edgeFromList;
	NSUInteger* __edgeToList;
	
	float* __edgesWeights;
	float* __verticesWeights;
	
	NSUInteger __vertexCapacity;
	NSUInteger __edgesCapacity;
	
	//float* adjacencyMatrix;
	//SCINumberArray* __edgeFromList; // change to resizable.
	//SCINumberArray* __edgeToList;  // change to resizable.
	//SCINumberArray* __edgesWeights; 
	//SCINumberArray* __verticesWeights; 
	
	NSMutableDictionary* __verticesProperties;
	NSMutableDictionary* __edgesProperties;

	
	NSUInteger __edgesCount;
	NSUInteger __verticesCount;
	NSMutableArray* __vertices;
	NSMutableArray* __edges;
	BOOL _SCI_editable;
	BOOL _SCI_directed;
	BOOL _SCI_edgeWeighted;
	BOOL _SCI_vertexWeighted;
}
//Default Models:


//Initializers
#pragma mark Initializers
-initWithVertices:(NSArray *)vertices edges:(NSArray *)edges;
-initWithVertices:(NSArray *)vertices linkFromVertices:(NSArray *)fromVertices toVertices:(NSArray *)toVertices;
-initWithLinksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices;
-initWithVerticesCount:(NSUInteger)count linksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices;

-initWithVertexCapacity:(NSUInteger)vertexCount edgeCapacity:(NSUInteger)edgeCount;
-initWithNetwork:(SCINetwork *)network;
-initWithNetwork:(SCINetwork *)network byExpandingVertexCapacityWith:(NSUInteger)vertexCount edgeCapacityWith:(NSUInteger)edgeCount;
-initWithVerticesString:(NSString *)verticesString edgesString:(NSString*)edgesString;
-initWithVerticesString:(NSString *)verticesString fromLinksString:(NSString*)fromLinksString toLinksString:(NSString*)toLinkString;


-initByMergingNetworksInArray:(NSArray*)networks; //New Property originalNetwork will be created.





-initWithVertices:(NSArray *)vertices edges:(NSArray *)edges directed:(BOOL)directed;
-initWithVertices:(NSArray *)vertices linkFromVertices:(NSArray *)fromVertices toVertices:(NSArray *)toVertices directed:(BOOL)directed;
-initWithLinksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices directed:(BOOL)directed;
-initWithVerticesCount:(NSUInteger)count linksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices directed:(BOOL)directed;

-initWithVertexCapacity:(NSUInteger)vertexCount edgeCapacity:(NSUInteger)edgeCount directed:(BOOL)directed;
-initWithNetwork:(SCINetwork *)network directed:(BOOL)directed;
-initWithNetwork:(SCINetwork *)network byExpandingVertexCapacityWith:(NSUInteger)vertexCount edgeCapacityWith:(NSUInteger)edgeCount directed:(BOOL)directed;
-initWithVerticesString:(NSString *)verticesString edgesString:(NSString*)edgesString directed:(BOOL)directed;
-initWithVerticesString:(NSString *)verticesString fromLinksString:(NSString*)fromLinksString toLinksString:(NSString*)toLinkString directed:(BOOL)directed;



-initWithVertices:(NSArray *)vertices edges:(NSArray *)edges directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
-initWithVertices:(NSArray *)vertices linkFromVertices:(NSArray *)fromVertices toVertices:(NSArray *)toVertices directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
-initWithLinksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
-initWithVerticesCount:(NSUInteger)count linksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;

-initWithVertexCapacity:(NSUInteger)vertexCount edgeCapacity:(NSUInteger)edgeCount directed:(BOOL)directed verticesWeighted:(BOOL)verticesWeighted edgesWeighted:(BOOL)edgesWeighted;
-initWithNetwork:(SCINetwork *)network directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
-initWithNetwork:(SCINetwork *)network byExpandingVertexCapacityWith:(NSUInteger)vertexCount edgeCapacityWith:(NSUInteger)edgeCount directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
-initWithVerticesString:(NSString *)verticesString edgesString:(NSString*)edgesString directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
-initWithVerticesString:(NSString *)verticesString fromLinksString:(NSString*)fromLinksString toLinksString:(NSString*)toLinkString directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;

-initWithEdgesListString:(NSString*)edgesListString directed:(BOOL)directed;

#pragma mark -
#pragma mark New Networks methods

-initBarabasiNetworkWithInitialVertices:(NSUInteger)initial degreeGrowth:(NSUInteger)degreeGrowth iterations:(NSUInteger)iterations;
-initBarabasiNetworkWitNumberOfVertices:(NSUInteger)numberOfVertices approximateDegree:(NSUInteger)degree;
-initRandomNetworkWithNumberOfVertices:(NSUInteger)numberOfVertices degree:(double)degree;
-initGeographicalNetworkWithNetwork:(SCINetwork*)baseNetwork maximumDistance:(double)maxDistance;
-initGeographicalNetworkWithNetwork:(SCINetwork*)baseNetwork positions:(id<SCIVectorArray>)vectorPositions maximumDistance:(double)maxDistance;
-initRegularNetworkWithNumberOfVertices:(NSUInteger)numberOfVertices bordered:(BOOL)bordered;
-initWattzStrogatzNetworkWithNumberOfVertices:(NSUInteger)numberOfVertices degree:(NSUInteger)degree reconnectionProbability:(double)probability;



#pragma mark -
#pragma mark Creators

+(SCINetwork*)networkWithVertices:(NSArray *)vertices edges:(NSArray *)edges;
+(SCINetwork*)networkWithVertices:(NSArray *)vertices linkFromVertices:(NSArray *)fromVertices toVertices:(NSArray *)toVertices;
+(SCINetwork*)networkWithLinksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices;

+(SCINetwork*)networkWithVertexCapacity:(NSUInteger)vertexCount edgeCapacity:(NSUInteger)edgeCount;
+(SCINetwork*)networkWithNetwork:(SCINetwork *)network;
+(SCINetwork*)networkWithNetwork:(SCINetwork *)network byExpandingVertexCapacityWith:(NSUInteger)vertexCount edgeCapacityWith:(NSUInteger)edgeCount;
+(SCINetwork*)networkWithVerticesString:(NSString *)verticesString edgesString:(NSString*)edgesString;
+(SCINetwork*)networkWithVerticesString:(NSString *)verticesString fromLinksString:(NSString*)fromLinksString toLinksString:(NSString*)toLinkString;

+(SCINetwork*)networkByMergingNetworksInArray:(NSArray*)networks; //New Propertie originalNetwork will be created.



+(SCINetwork*)networkWithVertices:(NSArray *)vertices edges:(NSArray *)edges directed:(BOOL)directed;
+(SCINetwork*)networkWithVertices:(NSArray *)vertices linkFromVertices:(NSArray *)fromVertices toVertices:(NSArray *)toVertices directed:(BOOL)directed;
+(SCINetwork*)networkWithLinksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices directed:(BOOL)directed;

+(SCINetwork*)networkWithVertexCapacity:(NSUInteger)vertexCount edgeCapacity:(NSUInteger)edgeCount directed:(BOOL)directed;
+(SCINetwork*)networkWithNetwork:(SCINetwork *)network directed:(BOOL)directed;
+(SCINetwork*)networkWithNetwork:(SCINetwork *)network byExpandingVertexCapacityWith:(NSUInteger)vertexCount edgeCapacityWith:(NSUInteger)edgeCount directed:(BOOL)directed;
+(SCINetwork*)networkWithVerticesString:(NSString *)verticesString edgesString:(NSString*)edgesString directed:(BOOL)directed;
+(SCINetwork*)networkWithVerticesString:(NSString *)verticesString fromLinksString:(NSString*)fromLinksString toLinksString:(NSString*)toLinkString directed:(BOOL)directed;




+(SCINetwork*)networkWithVertices:(NSArray *)vertices edges:(NSArray *)edges directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
+(SCINetwork*)networkWithVertices:(NSArray *)vertices linkFromVertices:(NSArray *)fromVertices toVertices:(NSArray *)toVertices directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
+(SCINetwork*)networkWithLinksIndexedFrom:(SCINumberArray *)fromVerticesIndices toIndices:(SCINumberArray *)toVerticesIndices directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;

+(SCINetwork*)networkWithVertexCapacity:(NSUInteger)vertexCount edgeCapacity:(NSUInteger)edgeCount directed:(BOOL)directed verticesWeighted:(BOOL)verticesWeighted edgesWeighted:(BOOL)edgesWeighted;
+(SCINetwork*)networkWithNetwork:(SCINetwork *)network directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
+(SCINetwork*)networkWithNetwork:(SCINetwork *)network byExpandingVertexCapacityWith:(NSUInteger)vertexCount edgeCapacityWith:(NSUInteger)edgeCount directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
+(SCINetwork*)networkWithVerticesString:(NSString *)verticesString edgesString:(NSString*)edgesString directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;
+(SCINetwork*)networkWithVerticesString:(NSString *)verticesString fromLinksString:(NSString*)fromLinksString toLinksString:(NSString*)toLinkString directed:(BOOL)directed verticesWeights:(SCINumberArray*)verticesWeights edgesWeights:(SCINumberArray*)edgesWeights;



#pragma mark Creators of Network Models:

+(SCINetwork*)barabasiNetworkWithInitialVertices:(NSUInteger)initial degreeGrowth:(NSUInteger)degreeGrowth iterations:(NSUInteger)iterations;

+(SCINetwork*)barabasiNetworkWitNumberOfVertices:(NSUInteger)numberOfVertices approximateDegree:(NSUInteger)degree;

+(SCINetwork*)randomNetworkWithNumberOfVertices:(NSUInteger)numberOfVertices degree:(double)degree;

+(SCINetwork*)geographicalNetworkWithNetwork:(SCINetwork*)baseNetwork maximumDistance:(double)maxDistance;

+(SCINetwork*)geographicalNetworkWithNetwork:(SCINetwork*)baseNetwork positions:(id<SCIVectorArray>)vectorPositions maximumDistance:(double)maxDistance;

+(SCINetwork*)regularNetworkWithNumberOfVertices:(NSUInteger)numberOfVertices bordered:(BOOL)bordered;

+(SCINetwork*)wattzStrogatzNetworkWithNumberOfVertices:(NSUInteger)numberOfVertices degree:(NSUInteger)degree reconnectionProbability:(double)probability;


#pragma mark Methods for get Vertices and Indices
-(SCIVertex*) vertexAtIndex:(NSUInteger) vertexIndex;
-(SCIEdge*) edgeAtIndex:(NSUInteger) edgeIndex;
-(SCIVertex*) vertexWithName:(NSString*) vertexName;
-(NSArray*) verticesWithName:(NSString*) vertexName;

-(NSUInteger) countEdges;
-(NSUInteger) countVertices;


#pragma mark Methods for number of Edges or vertices (by index)
-(NSUInteger) countEdgesOfVertexAtIndex:(NSUInteger) vertexIndex;
-(NSUInteger) countInEdgesOfVertexAtIndex:(NSUInteger) vertexIndex;
-(NSUInteger) countToVerticesOfVertexAtIndex:(NSUInteger) vertexIndex;
-(NSUInteger) countFromVerticesOfVertexAtIndex:(NSUInteger) vertexIndex;

#pragma mark Methods calculating the degree of vertices
-(double) calcDegreeOfVertexAtIndex:(NSUInteger) vertexIndex;
-(double) calcInDegreeOfVertexAtIndex:(NSUInteger) vertexIndex;

-(double) calcDegreeOfVertex:(SCIVertex*) vertex;
-(double) calcInDegreeOfVertex:(SCIVertex*) vertex;

-(double) calcStrengthOfVertexAtIndex:(NSUInteger) vertexIndex;
-(double) calcInStrengthOfVertexAtIndex:(NSUInteger) vertexIndex;


#pragma mark Methods for number of Edges or vertices
-(NSUInteger) countEdgesOfVertex:(SCIVertex*) vertex;
-(NSUInteger) countInEdgesOfVertex:(SCIVertex*) vertex;
-(NSUInteger) countToVerticesOfVertex:(SCIVertex*) vertex;
-(NSUInteger) countFromVerticesOfVertex:(SCIVertex*) vertex;

#pragma mark Methods for get Edges Linked To a Vertex (by Index)
-(NSArray*) edgesLinkedToVertexAtIndex:(NSUInteger) vertexIndex;
-(NSArray*) edgesLinkedFromVertexAtIndex:(NSUInteger) vertexIndex;

#pragma mark Methods for get Vertices Linked To a Vertex (by Index)
-(NSArray*) verticesLinkedToVertexAtIndex:(NSUInteger) vertexIndex;
-(NSArray*) verticesLinkedFromVertexAtIndex:(NSUInteger) vertexIndex;

#pragma mark Methods for get Edges Linked To a Vertex
-(NSArray*) edgesLinkedToVertex:(SCIVertex*) vertex;
-(NSArray*) edgesLinkedFromVertex:(SCIVertex*) vertex;

#pragma mark Methods for get Vertices Linked To a Vertex
-(NSArray*) verticesLinkedToVertex:(SCIVertex*) vertex;
-(NSArray*) verticesLinkedFromVertex:(SCIVertex*) vertex;

#pragma mark Methods for get indices of Vertices Linked To a Vertex (by Index)
-(SCINumberArray*) indicesOfVerticesLinkedToVertexAtIndex:(NSUInteger) vertexIndex;
-(SCINumberArray*) indicesOfVerticesLinkedFromVertexAtIndex:(NSUInteger) vertexIndex;

#pragma mark Methods for get indices of Edges Linked To a Vertex (by Index)
-(SCINumberArray*) indicesOfEdgesLinkedToVertexAtIndex:(NSUInteger) vertexIndex;
-(SCINumberArray*) indicesOfEdgesLinkedFromVertexAtIndex:(NSUInteger) vertexIndex;

#pragma mark Methods for get indices of Vertices Linked To a Vertex:
-(SCINumberArray*) indicesOfVerticesLinkedTo:(SCIVertex*) vertex;
-(SCINumberArray*) indicesOfVerticesLinkedFrom:(SCIVertex*) vertex;

#pragma mark Methods for get indices of Edges Linked To a Vertex:
-(SCINumberArray*) indicesOfEdgesLinkedToVertex:(SCIVertex*) vertex;
-(SCINumberArray*) indicesOfEdgesLinkedFromVertex:(SCIVertex*) vertex;


#pragma mark Methods for get properties of a vertex (by index):
-(NSDictionary*) propertiesOfVerticesAtIndexArray:(SCINumberArray*) verticesIndices;
-(NSArray*) propertiesOfVerticesAtIndexArray:(SCINumberArray*) verticesIndices forKey:(id)key;
-(NSArray*) namesOfVerticesAtIndexArray:(SCINumberArray*) verticesIndices;
-(SCINumberArray*) areEditableVerticesAtIndexArray:(SCINumberArray*) verticesIndices;

#pragma mark Methods for get properties of a edges (by index):
-(NSArray*) propertiesOfEdgesAtIndexArray:(SCINumberArray*)edgesIndices forKey:(id)key;
-(NSArray*) namesOfEdgesAtIndexArray:(SCINumberArray*)edgesIndices;
-(SCINumberArray*) areEditableEdgesAtIndexArray:(SCINumberArray*)edgesIndices;


#pragma mark Methods for get properties of a vertex (by index):
-(NSDictionary*) propertiesOfVertexAtIndex:(NSInteger)index;


#pragma mark Methods for get properties of a edges (by index):
-(NSDictionary*) propertiesOfEdgeAtIndex:(NSInteger)index;


#pragma mark weight methods:
-(SCINumberArray*) verticesWeightValues;
-(SCINumberArray*) edgesWeightValues;

#pragma -
#pragma editing methods
#pragma mark set methods (by index):

-(void) setVerticesWeightValues:(SCINumberArray*)weightValues;
-(void) setEdgesWeightValues:(SCINumberArray*)weightValues;
-(void) setPropertiesOfVertices:(NSArray*)properties forKey:(id)key;
-(void) setPropertiesOfEdges:(NSArray*)properties forKey:(id)key;

#pragma mark set methods (by index):


-(void) setWeightValue:(float)weightValue atVertexIndex:(NSInteger)index;
-(void) setWeightValue:(float)weightValue atEdgeIndex:(NSInteger)index;
-(void) setPropertyValue:(id)object forKey:(id)key atVertexIndex:(NSInteger)index;
-(void) setPropertyValue:(id)object forKey:(id)key atEdgeIndex:(NSInteger)index;


-(void) addEdgesFromVerticesIndices:(NSUInteger*)fromIndices toVerticesIndices:(NSUInteger*)toIndices count:(NSUInteger)count;
-(SCIEdge*) linkVertex:(SCIVertex*)fromVertex to:(SCIVertex*)toVertex;
-(SCIEdge*) linkVertex:(SCIVertex*)fromVertex to:(SCIVertex*)toVertex weight:(float)weight;


-(SCIEdge*) reLinkVertex:(SCIVertex*)fromVertex to:(SCIVertex*)toVertex atIndex:(NSInteger)index;
-(SCIEdge*) reLinkVertex:(SCIVertex*)fromVertex to:(SCIVertex*)toVertex weight:(float)weight atIndex:(NSInteger)index;

-(NSArray*) keysForPropertiesOfVertices;
-(NSArray*) keysForPropertiesOfEdges;

-(NSDictionary*) propertiesOfVertices;
-(NSDictionary*) propertiesOfEdges;

//TODO: method UPDATE?
-(BOOL) blockEditing;
-(BOOL) isEditable;
-(BOOL) isDirected;
-(BOOL) isEdgeWeighted;
-(BOOL) isVertexWeighted;


-(NSArray*) vertices;
-(NSArray*) edges;

-(float*) buildAdjacencyMatrixInPointer:(float*) matrixPointer;


#pragma mark StrinFile methods:
-(NSString*) formattedStringValue;
-(BOOL)writeToFile:(NSString *)path atomically:(BOOL)flag;
-(BOOL)writeToURL:(NSURL *)aURL atomically:(BOOL)flag;

-initWithNetworkFormattedString:(NSString *)formattedString;

-initWithContentsOfFile:(NSString *)path;
-initWithContentsOfURL:(NSURL *)aURL;

+(SCINetwork*)networkWithContentsOfFile:(NSString *)path;
+(SCINetwork*)numberArrayWithContentsOfURL:(NSURL *)aURL;


#pragma mark edgesList methods:
-(NSString*) edgesListFormattedStringValue;
-(BOOL)writeToEdgesFile:(NSString *)path atomically:(BOOL)flag;
-(BOOL)writeToEdgesURL:(NSURL *)aURL atomically:(BOOL)flag;

#pragma mark PajekNet methods:
-(NSString*) pajekFormattedStringValue;
-(BOOL)writeToPajekFile:(NSString *)path atomically:(BOOL)flag;
-(BOOL)writeToPajekURL:(NSURL *)aURL atomically:(BOOL)flag;

-initWithNetworkPajekFormattedString:(NSString *)formattedString;

-initWithContentsOfPajekFile:(NSString *)path;
-initWithContentsOfPajekURL:(NSURL *)aURL;

+(SCINetwork*)networkWithContentsOfPajekFile:(NSString *)path;
+(SCINetwork*)numverArrayWithContentsOfPajekURL:(NSURL *)aURL;

#pragma mark ExtraCalculations:
-(SCINumberArray*)calcDegrees;
-(SCINumberArray*)calcInDegrees;
-(SCINumberArray*)calcStrengths;
-(SCINumberArray*)calcInStrengths;

-(NSString*) __SCI_MatrixDebug;


#pragma mark Utility:
-(NSArray*) connectedSubNetworksArray;
-(SCINetwork*) largestConnectedSubNetwork;

@end
