//
//  SCIVector2dArray.h
//  SciObjects
//
//  Created by Filipi Nascimento Silva on 03/26/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SciObjects_consts.h"
#import "SCIVectorArray.h"

@class SCIVector2dArray_initializer,SCIVector2dArray,SCIVector2dArray,SCIVector3dArray,SCIVector3dArray;

@interface SCIVector2dArray : NSArray <SCIVectorArray, SCIEditableArray>{
	
	
}
#pragma mark Initializers
-initWithSize:(NSUInteger)count;
-initWithVector2d:(SCIVector2d*)vector count:(NSUInteger)count;
-initWithScalar:(NSNumber*)scalar count:(NSUInteger)count;

-initWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY;
-initWithXY:(SCIVector2dArray*)newXY;

-initWithVector2dArray:(SCIVector2dArray*)newVector2dArray;
-initWithArray:(NSArray *)array;


-initWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithVector2d:(SCIVector2d*)vector count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithScalar:(NSNumber*)scalar count:(NSUInteger)count precision:(SCIVectorPrecision)precision;

-initWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY precision:(SCIVectorPrecision)precision;
-initWithXY:(SCIVector2dArray*)newXY precision:(SCIVectorPrecision)precision;

-initWithVector2dArray:(SCIVector2dArray*)newVector2dArray precision:(SCIVectorPrecision)precision;
-initWithArray:(NSArray *)array precision:(SCIVectorPrecision)precision;


-initWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithXY:(SCIVector2dArray*)newXY count:(NSUInteger)count precision:(SCIVectorPrecision)precision;

-initWithVector2dArray:(SCIVector2dArray*)newVector2dArray count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithArray:(NSArray *)array count:(NSUInteger)count precision:(SCIVectorPrecision)precision;



-initWithVector2dArray:(SCIVector2dArray*)newVector2dArray range:(NSRange)range;
-initWithVector2dArray:(SCIVector2dArray*)newVector2dArray indices:(SCINumberArray*)indices;

-initWithVector2dArray:(SCIVector2dArray*)newVector2dArray range:(NSRange)range precision:(SCIVectorPrecision)precision;
-initWithVector2dArray:(SCIVector2dArray*)newVector2dArray indices:(SCINumberArray*)indices precision:(SCIVectorPrecision)precision;


-initByMergingVector2dArrays:(NSArray*)vector2dArrays;

-initByMergingVector2dArrays:(NSArray*)vector2dArrays precision:(SCIVectorPrecision)precision;


#pragma mark Double Initializers:

-initWithXd:(double*)newXd Yd:(double*)newYd count:(NSUInteger)count;

-initWithDouble:(double)scalar count:(NSUInteger)count;


#pragma mark Float Initializers:

-initWithXf:(float*)newXf Yf:(float*)newYf count:(NSUInteger)count;

-initWithFloat:(float)scalar count:(NSUInteger)count;

#pragma mark Creators

+(SCIVector2dArray*)vector2dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY;
+(SCIVector2dArray*)vector2dArrayWithXY:(SCIVector2dArray*)newXY;

+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray;
+(SCIVector2dArray*)vector2dArrayWithArray:(NSArray *)array;

+(SCIVector2dArray*)vector2dArrayWithSize:(NSUInteger)count;
+(SCIVector2dArray*)vector2dArrayWithVector2d:(SCIVector2d*)vector count:(NSUInteger)count;
+(SCIVector2dArray*)vector2dArrayWithScalar:(NSNumber*)scalar count:(NSUInteger)count;


+(SCIVector2dArray*)vector2dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithXY:(SCIVector2dArray*)newXY precision:(SCIVectorPrecision)precision;


+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithArray:(NSArray *)array precision:(SCIVectorPrecision)precision;

+(SCIVector2dArray*)vector2dArrayWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithVector2d:(SCIVector2d*)vector count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithScalar:(NSNumber*)scalar count:(NSUInteger)count precision:(SCIVectorPrecision)precision;



+(SCIVector2dArray*)vector2dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY count:(NSUInteger)count;
+(SCIVector2dArray*)vector2dArrayWithXY:(SCIVector2dArray*)newXY count:(NSUInteger)count;

+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray count:(NSUInteger)count;
+(SCIVector2dArray*)vector2dArrayWithArray:(NSArray *)array count:(NSUInteger)count;


+(SCIVector2dArray*)vector2dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithXY:(SCIVector2dArray*)newXY count:(NSUInteger)count precision:(SCIVectorPrecision)precision;

+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithArray:(NSArray *)array count:(NSUInteger)count precision:(SCIVectorPrecision)precision;


+(SCIVector2dArray*)zerosWithSize:(NSUInteger)count;
+(SCIVector2dArray*)onesWithSize:(NSUInteger)count;

+(SCIVector2dArray*)zerosWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)onesWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;


+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray range:(NSRange)range;
+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray indices:(SCINumberArray*)indices;

+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray range:(NSRange)range precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithVector2dArray:(SCIVector2dArray*)newVector2dArray indices:(SCINumberArray*)indices precision:(SCIVectorPrecision)precision;



+(SCIVector2dArray*)vector2dArrayByMergingVector2dArrays:(NSArray*)vector2dArrays;

+(SCIVector2dArray*)vector2dArrayByMergingVector2dArrays:(NSArray*)vector2dArrays precision:(SCIVectorPrecision)precision;



#pragma mark Double Creators:

+(SCIVector2dArray*)vector2dArrayWithXd:(double*)newXd Yd:(double*)newYd count:(NSUInteger)count;


+(SCIVector2dArray*)zerosDoubleWithSize:(NSUInteger)count;
+(SCIVector2dArray*)onesDoubleWithSize:(NSUInteger)count;

+(SCIVector2dArray*)vector2dArrayWithDouble:(double)scalar count:(NSUInteger)count;

#pragma mark Float Creators:

+(SCIVector2dArray*)vector2dArrayWithXf:(float*)newXf Yf:(float*)newYf count:(NSUInteger)count;

+(SCIVector2dArray*)zerosFloatsWithSize:(NSUInteger)count;
+(SCIVector2dArray*)onesFloatsWithSize:(NSUInteger)count;

+(SCIVector2dArray*)vector2dArrayWithFloat:(float)scalar count:(NSUInteger)count;

#pragma mark Get accessors

-(SCIVector2d*)vectorAtIndex:(NSUInteger)index;


-(SCINumberArray*)x; 
-(SCINumberArray*)y;

-(SCIVector2dArray*)xx;
-(SCIVector2dArray*)yy;

-(SCIVector2dArray*)xy;
-(SCIVector2dArray*)yx;

-(SCIVector3dArray*)xxx;
-(SCIVector3dArray*)xyy;

-(SCIVector3dArray*)xxy;
-(SCIVector3dArray*)xyx;


-(SCIVector3dArray*)yxx;
-(SCIVector3dArray*)yyy;

-(SCIVector3dArray*)yxy;
-(SCIVector3dArray*)yyx;


#pragma mark Set accessors
-(void)setVector:(SCIVector2d*)vector atIndex:(NSUInteger)index;
-(void)setX:(SCINumberArray*)newX;
-(void)setY:(SCINumberArray*)newY;
-(void)setXY:(SCIVector2dArray*)newXY;
-(void)setX:(SCINumberArray*)newX Y:(SCINumberArray*)newY; 



#pragma mark Operations
-(SCINumberArray *)magnitude;
-(SCINumberArray *)squaredMagnitude;
-(SCINumberArray *)argument;

-(SCIVector2dArray *)versor;
-(SCIVector2dArray *)negative;
-(SCIVector2dArray *)absolute;

-(SCIVector2dArray *)add:(SCIVector2dArray *)vector;
-(SCIVector2dArray *)sub:(SCIVector2dArray *)vector;
-(SCIVector2dArray *)mul:(SCIVector2dArray *)vector;
-(SCIVector2dArray *)div:(SCIVector2dArray *)vector;

-(SCIVector2dArray *)addScalar:(SCINumberArray *)numberArray;
-(SCIVector2dArray *)subScalar:(SCINumberArray *)numberArray;
-(SCIVector2dArray *)mulScalar:(SCINumberArray *)numberArray;
-(SCIVector2dArray *)divScalar:(SCINumberArray *)numberArray;

//-(SCINumberArray *)dot:(SCIVector2dArray *)vector;
// FIXME: "Implements in Future."
//-(SCIVector2dArray *)cross:(SCIVector2dArray *);


#pragma mark SelfOperations
-(SCIVector2dArray *)normalize; //selfVersor
-(SCIVector2dArray *)negate; //selfNegative
-(SCIVector2dArray *)selfAbsolute;

-(SCIVector2dArray *)selfAdd:(SCIVector2dArray *)vector;
-(SCIVector2dArray *)selfSub:(SCIVector2dArray *)vector;
-(SCIVector2dArray *)selfMul:(SCIVector2dArray *)vector;
-(SCIVector2dArray *)selfDiv:(SCIVector2dArray *)vector;

-(SCIVector2dArray *)selfAddScalar:(SCINumberArray *)numberArray;
-(SCIVector2dArray *)selfSubScalar:(SCINumberArray *)numberArray;
-(SCIVector2dArray *)selfMulScalar:(SCINumberArray *)numberArray;
-(SCIVector2dArray *)selfDivScalar:(SCINumberArray *)numberArray;

// FIXME: "implementar futuramente"
//-(SCIVector2dArray *)selfDot:(SCIVector2dArray *)vector;


#pragma mark ArrayExtras
-(SCIVector2d *)sumVector;
-(SCIVector2d *)averageVector;


-(SCIVector2d *)magnitudeSumVector;
-(SCIVector2d *)absoluteSumVector;

#pragma mark Optimization Code:

-(BOOL)optimizeForCalculations;

-(BOOL)clearOptimizationForCalculations;

-(BOOL)isOptimizedForCalculations;

-(void*)pointerForX;
-(void*)pointerForY;

-(void*)vectorizedPointerForX;
-(void*)vectorizedPointerForY;


-(void)replaceObject:(id)object atIndex:(NSInteger)index;


#pragma mark StringMethods
-initWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator;
-initWithString:(NSString*)numberString separator:(NSString*)separator precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString separator:(NSString*)separator;
-initWithString:(NSString*)numberString;

+(SCIVector2dArray *)vector2dArrayWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray *)vector2dArrayWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator;
+(SCIVector2dArray *)vector2dArrayWithString:(NSString*)numberString separator:(NSString*)separator precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray *)vector2dArrayWithString:(NSString*)numberString precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray *)vector2dArrayWithString:(NSString*)numberString separator:(NSString*)separator;
+(SCIVector2dArray *)vector2dArrayWithString:(NSString*)numberString;



-(NSString*) stringValue;
-(NSString*) stringValueWithVectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator;
-(NSString*) stringValueWithSeparator:(NSString*)separator;


#pragma mark FileMethods
-initWithContentsOfFile:(NSString *)path;
-initWithContentsOfURL:(NSURL *)aURL;
-initWithContentsOfFile:(NSString *)path precision:(SCIVectorPrecision)precision;
-initWithContentsOfURL:(NSURL *)aURL precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithContentsOfFile:(NSString *)path precision:(SCIVectorPrecision)precision;
+(SCIVector2dArray*)vector2dArrayWithContentsOfURL:(NSURL *)aURL precision:(SCIVectorPrecision)precision;
-(BOOL)writeToFile:(NSString *)path atomically:(BOOL)flag;
-(BOOL)writeToURL:(NSURL *)aURL atomically:(BOOL)flag;


@end

#pragma mark -
@interface SCIVector2dArray (SCIVector2dArrayPrimitiveAdditions)
#pragma mark Double Methods Additions:
#pragma mark Double get accessors

-(SCIVector2d*)doubleVectorAtIndex:(NSUInteger)index;

-(double*)xd; 
-(double*)yd;

#pragma mark Double set accessors

-(void)setXd:(double*)newXd;
-(void)setYd:(double*)newYd;
-(void)setXd:(double*)newXd Yd:(double*)newYd;


#pragma mark Float Methods Additions:
#pragma mark Float get accessors

-(SCIVector2d*)floatVectorAtIndex:(NSUInteger)index;

-(float*)xfv; 
-(float*)yfv;

#pragma mark Float set accessors
-(void)setXf:(float*)newXf;
-(void)setYf:(float*)newYf;
-(void)setXf:(float*)newXf Yf:(float*)newYf;



#pragma mark Double Operations
-(double)doubleMagnitude;
-(double)doubleSquaredMagnitude;
-(double)doubleArgument;

-(SCIVector2dArray *)addDouble:(double)doubleNumber;
-(SCIVector2dArray *)subDouble:(double)doubleNumber;
-(SCIVector2dArray *)mulDouble:(double)doubleNumber;
-(SCIVector2dArray *)divDouble:(double)doubleNumber;


#pragma mark Double SelfOperations
-(SCIVector2dArray *)selfAddDouble:(double)doubleNumber;
-(SCIVector2dArray *)selfSubDouble:(double)doubleNumber;
-(SCIVector2dArray *)selfMulDouble:(double)doubleNumber;
-(SCIVector2dArray *)selfDivDouble:(double)doubleNumber;

#pragma mark Float Operations
-(float)floatMagnitude;
-(float)floatSquaredMagnitude;
-(float)floatArgument;

-(SCIVector2dArray *)addFloat:(float)floatNumber;
-(SCIVector2dArray *)subFloat:(float)floatNumber;
-(SCIVector2dArray *)mulFloat:(float)floatNumber;
-(SCIVector2dArray *)divFloat:(float)floatNumber;


#pragma mark Float SelfOperations

-(SCIVector2dArray *)selfAddFloat:(float)floatNumber;
-(SCIVector2dArray *)selfSubFloat:(float)floatNumber;
-(SCIVector2dArray *)selfMulFloat:(float)floatNumber;
-(SCIVector2dArray *)selfDivFloat:(float)floatNumber;

@end
