//
//  SCIVector3d.h
//  SciObjects
//
//  Created by Filipi Nascimento Silva on 03/19/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SciObjects_consts.h"
#import "SCIVector.h"
#import "SCIVector2d.h"
@class SCIVector3d_initializer,SCIVector3d,SCIVector2d;

@interface SCIVector3d : NSArray <SCIVector,NSCoding, NSCopying>{
	
}
#pragma mark Initializers

-initWithX:(NSNumber*)newX Y:(NSNumber*)newY Z:(NSNumber*)newZ;
-initWithXYZ:(SCIVector3d*)newXYZ;
-initWithXY:(SCIVector2d*)newXY Z:(NSNumber*)newZ;
-initWithX:(NSNumber*)newX YZ:(SCIVector2d*)newYZ;

-initWithVector3d:(SCIVector3d*)newVector3d;
-initWithArray:(NSArray *)array;

-initWithX:(NSNumber*)newX Y:(NSNumber*)newY Z:(NSNumber*)newZ precision:(SCIVectorPrecision)precision;
-initWithXYZ:(SCIVector3d*)newXYZ precision:(SCIVectorPrecision)precision;
-initWithX:(NSNumber*)newX YZ:(SCIVector2d*)newYZ precision:(SCIVectorPrecision)precision;
-initWithXY:(SCIVector2d*)newXY Z:(NSNumber*)newZ precision:(SCIVectorPrecision)precision;

-initWithVector3d:(SCIVector3d*)newVector3d precision:(SCIVectorPrecision)precision;
-initWithArray:(NSArray *)array precision:(SCIVectorPrecision)precision;
#pragma mark Creators

+(SCIVector3d*)vector3dWithX:(NSNumber*)newX Y:(NSNumber*)newY Z:(NSNumber*)newZ;
+(SCIVector3d*)vector3dWithXYZ:(SCIVector3d*)newXYZ;
+(SCIVector3d*)vector3dWithXY:(SCIVector2d*)newXY Z:(NSNumber*)newZ;
+(SCIVector3d*)vector3dWithX:(NSNumber*)newX YZ:(SCIVector2d*)newYZ;

+(SCIVector3d*)vector3dWithVector3d:(SCIVector3d*)newVector3d;
+(SCIVector3d*)vector3dWithArray:(NSArray *)array;


+(SCIVector3d*)vector3dWithX:(NSNumber*)newX Y:(NSNumber*)newY Z:(NSNumber*)newZ precision:(SCIVectorPrecision)precision;
+(SCIVector3d*)vector3dWithXYZ:(SCIVector3d*)newXYZ precision:(SCIVectorPrecision)precision;
+(SCIVector3d*)vector3dWithXY:(SCIVector2d*)newXY Z:(NSNumber*)newZ precision:(SCIVectorPrecision)precision;
+(SCIVector3d*)vector3dWithX:(NSNumber*)newX YZ:(SCIVector2d*)newYZ precision:(SCIVectorPrecision)precision;

+(SCIVector3d*)vector3dWithVector3d:(SCIVector3d*)newVector3d precision:(SCIVectorPrecision)precision;
+(SCIVector3d*)vector3dWithArray:(NSArray *)array precision:(SCIVectorPrecision)precision;

+(SCIVector3d*)zero;
+(SCIVector3d*)one;

#pragma mark Get accessors

-(NSNumber*)x; 
-(NSNumber*)y;
-(NSNumber*)z;

-(SCIVector2d*)xx;
-(SCIVector2d*)yy;
-(SCIVector2d*)zz;

-(SCIVector2d*)xy;
-(SCIVector2d*)yx;

-(SCIVector2d*)xz;
-(SCIVector2d*)zx;

-(SCIVector2d*)yz;
-(SCIVector2d*)zy;


-(SCIVector3d*)xxx;
-(SCIVector3d*)xyy;
-(SCIVector3d*)xzz;

-(SCIVector3d*)xxy;
-(SCIVector3d*)xyx;

-(SCIVector3d*)xxz;
-(SCIVector3d*)xzx;

-(SCIVector3d*)xyz;
-(SCIVector3d*)xzy;


-(SCIVector3d*)yxx;
-(SCIVector3d*)yyy;
-(SCIVector3d*)yzz;

-(SCIVector3d*)yxy;
-(SCIVector3d*)yyx;

-(SCIVector3d*)yxz;
-(SCIVector3d*)yzx;

-(SCIVector3d*)yyz;
-(SCIVector3d*)yzy;


-(SCIVector3d*)zxx;
-(SCIVector3d*)zyy;
-(SCIVector3d*)zzz;

-(SCIVector3d*)zxy;
-(SCIVector3d*)zyx;

-(SCIVector3d*)zxz;
-(SCIVector3d*)zzx;

-(SCIVector3d*)zyz;
-(SCIVector3d*)zzy; 

#pragma mark Set accessors

-(void)setXYZ:(SCIVector3d*)newXYZ;
-(void)setX:(NSNumber*)newX;
-(void)setY:(NSNumber*)newY;
-(void)setZ:(NSNumber*)newZ;
-(void)setXY:(SCIVector2d*)newXY Z:(NSNumber*)newZ;
-(void)setX:(NSNumber*)newX YZ:(SCIVector2d*)newYZ;
-(void)setX:(NSNumber*)newX Y:(NSNumber*)newY Z:(NSNumber*)newZ; 

#pragma mark Operations
-(NSNumber *)magnitude;
-(NSNumber *)squaredMagnitude;
-(NSNumber *)argument;

-(SCIVector3d *)versor;
-(SCIVector3d *)negative;
-(SCIVector3d *)absolute;

-(SCIVector3d *)add:(SCIVector3d *)vector;
-(SCIVector3d *)sub:(SCIVector3d *)vector;
-(SCIVector3d *)mul:(SCIVector3d *)vector;
-(SCIVector3d *)div:(SCIVector3d *)vector;

-(SCIVector3d *)addScalar:(NSNumber *)number;
-(SCIVector3d *)subScalar:(NSNumber *)number;
-(SCIVector3d *)mulScalar:(NSNumber *)number;
-(SCIVector3d *)divScalar:(NSNumber *)number;

//-(NSNumber *)dot:(SCIVector3d *)vector;
// FIXME: "implementar depois de SCIVector3d"
//-(SCIVector3d *)cross:(SCIVector3d *);


#pragma mark SelfOperations
-(SCIVector3d *)normalize; //selfVersor
-(SCIVector3d *)negate; //selfNegative
-(SCIVector3d *)selfAbsolute;

-(SCIVector3d *)selfAdd:(SCIVector3d *)vector;
-(SCIVector3d *)selfSub:(SCIVector3d *)vector;
-(SCIVector3d *)selfMul:(SCIVector3d *)vector;
-(SCIVector3d *)selfDiv:(SCIVector3d *)vector;

-(SCIVector3d *)selfAddScalar:(NSNumber *)number;
-(SCIVector3d *)selfSubScalar:(NSNumber *)number;
-(SCIVector3d *)selfMulScalar:(NSNumber *)number;
-(SCIVector3d *)selfDivScalar:(NSNumber *)number;

-(SCIVector3d *)selfDot:(SCIVector3d *)vector;

#pragma mark StringMethods
-initWithString:(NSString*)numberString separator:(NSString*)separator precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString separator:(NSString*)separator;
-initWithString:(NSString*)numberString;

+vector3dWithString:(NSString*)numberString separator:(NSString*)separator precision:(SCIVectorPrecision)precision;
+vector3dWithString:(NSString*)numberString precision:(SCIVectorPrecision)precision;
+vector3dWithString:(NSString*)numberString separator:(NSString*)separator;
+vector3dWithString:(NSString*)numberString;


-(NSString*) stringValue;
-(NSString*) stringValueWithSeparator:(NSString*)separator;

#pragma mark FileMethods
//-initWithContentsOfFile:(NSString *)path type:(SCINumberArrayType)type;
//-initWithContentsOfURL:(NSURL *)aURL type:(SCINumberArrayType)type;
//+(SCIVector2d*)vector2dWithContentsOfFile:(NSString *)path type:(SCINumberArrayType)type;
//+(SCIVector2d*)vector2dWithContentsOfURL:(NSURL *)aURL type:(SCINumberArrayType)type;


@end

#pragma mark -
@interface SCIVector3d (SCIVector3dPrimitiveAdditions)
#pragma mark Double Methods Additions:
#pragma mark Double Initializers:

-initWithXd:(double)newXd Yd:(double)newYd Zd:(double)newZd;
-initWithXYZd:(double*)newXYZ;
-initWithDoubles:(double*)newDoubles;


#pragma mark Double Creators:

+(SCIVector3d*)vector3dWithXd:(double)newXd Yd:(double)newYd Zd:(double)newZd;
+(SCIVector3d*)vector3dWithXYZd:(double*)newXYZd ;
+(SCIVector3d*)vector3dWithDoubles:(double*)newDoubles;

+(SCIVector3d*)zerod;
+(SCIVector3d*)oned;

#pragma mark Double get accessors

-(double)xd; 
-(double)yd;
-(double)zd;

-(double*)xxd;
-(double*)yyd;
-(double*)zzd;

-(double*)xyd;
-(double*)yxd;

-(double*)xzd;
-(double*)zxd;

-(double*)yzd;
-(double*)zyd;


-(double*)xxxd;
-(double*)xyyd;
-(double*)xzzd;

-(double*)xxyd;
-(double*)xyxd;

-(double*)xxzd;
-(double*)xzxd;

-(double*)xyzd;
-(double*)xzyd;


-(double*)yxxd;
-(double*)yyyd;
-(double*)yzzd;

-(double*)yxyd;
-(double*)yyxd;

-(double*)yxzd;
-(double*)yzxd;

-(double*)yyzd;
-(double*)yzyd;


-(double*)zxxd;
-(double*)zyyd;
-(double*)zzzd;

-(double*)zxyd;
-(double*)zyxd;

-(double*)zxzd;
-(double*)zzxd;

-(double*)zyzd;
-(double*)zzyd; 

#pragma mark Double set accessors

-(void)setXYZd:(double*)newXYZd;
-(void)setXd:(double)newXd;
-(void)setYd:(double)newYd;
-(void)setZd:(double)newZd;
-(void)setXd:(double)newXd Yd:(double)newYd Zd:(double)newZd;


#pragma mark Float Methods Additions:
#pragma mark Float Initializers:

-initWithXf:(float)newXf Yf:(float)newYf Zf:(float)newZf;
-initWithXYZf:(float*)newXYZ;
-initWithFloats:(float*)newFloats;


#pragma mark Float Creators:

+(SCIVector3d*)vector3dWithXf:(float)newXf Yf:(float)newYf Zf:(float)newZf;
+(SCIVector3d*)vector3dWithXYZf:(float*)newXYZf ;
+(SCIVector3d*)vector3dWithFloats:(float*)newFloats;

+(SCIVector3d*)zerof;
+(SCIVector3d*)onef;

#pragma mark Float get accessors

-(float)xf; 
-(float)yf;
-(float)zf;

-(float*)xxf;
-(float*)yyf;
-(float*)zzf;

-(float*)xyf;
-(float*)yxf;

-(float*)xzf;
-(float*)zxf;

-(float*)yzf;
-(float*)zyf;


-(float*)xxxf;
-(float*)xyyf;
-(float*)xzzf;

-(float*)xxyf;
-(float*)xyxf;

-(float*)xxzf;
-(float*)xzxf;

-(float*)xyzf;
-(float*)xzyf;


-(float*)yxxf;
-(float*)yyyf;
-(float*)yzzf;

-(float*)yxyf;
-(float*)yyxf;

-(float*)yxzf;
-(float*)yzxf;

-(float*)yyzf;
-(float*)yzyf;


-(float*)zxxf;
-(float*)zyyf;
-(float*)zzzf;

-(float*)zxyf;
-(float*)zyxf;

-(float*)zxzf;
-(float*)zzxf;

-(float*)zyzf;
-(float*)zzyf; 

#pragma mark Float set accessors

-(void)setXYZf:(float*)newXYZf;
-(void)setXf:(float)newXf;
-(void)setYf:(float)newYf;
-(void)setZf:(float)newZf;
-(void)setXf:(float)newXf Yf:(float)newYf Zf:(float)newZf;



#pragma mark Double Operations
-(double)doubleMagnitude;
-(double)doubleSquaredMagnitude;
-(double)doubleArgument;

-(SCIVector3d *)addDouble:(double)doubleNumber;
-(SCIVector3d *)subDouble:(double)doubleNumber;
-(SCIVector3d *)mulDouble:(double)doubleNumber;
-(SCIVector3d *)divDouble:(double)doubleNumber;


#pragma mark Double SelfOperations

-(SCIVector3d *)selfAddDouble:(double)doubleNumber;
-(SCIVector3d *)selfSubDouble:(double)doubleNumber;
-(SCIVector3d *)selfMulDouble:(double)doubleNumber;
-(SCIVector3d *)selfDivDouble:(double)doubleNumber;

#pragma mark Float Operations
-(float)floatMagnitude;
-(float)floatSquaredMagnitude;
-(float)floatArgument;

-(SCIVector3d *)addFloat:(float)floatNumber;
-(SCIVector3d *)subFloat:(float)floatNumber;
-(SCIVector3d *)mulFloat:(float)floatNumber;
-(SCIVector3d *)divFloat:(float)floatNumber;


#pragma mark Float SelfOperations

-(SCIVector3d *)selfAddFloat:(float)floatNumber;
-(SCIVector3d *)selfSubFloat:(float)floatNumber;
-(SCIVector3d *)selfMulFloat:(float)floatNumber;
-(SCIVector3d *)selfDivFloat:(float)floatNumber;


@end