//
//  SCIVector3dArray.h
//  SciObjects
//
//  Created by Filipi Nascimento Silva on 03/26/2008.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SciObjects_consts.h"
#import "SCIVectorArray.h"
@class SCIVector3dArray_initializer,SCIVector3dArray,SCIVector2dArray,SCIVector3d, SCIVector2d;

@interface SCIVector3dArray : NSArray <SCIVectorArray, SCIEditableArray>{

	
}
#pragma mark Initializers
-initWithSize:(NSUInteger)count;
-initWithVector3d:(SCIVector3d*)vector count:(NSUInteger)count;
-initWithScalar:(NSNumber*)scalar count:(NSUInteger)count;

-initWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ;
-initWithXYZ:(SCIVector3dArray*)newXYZ;
-initWithXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ;
-initWithX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ;

-initWithVector3dArray:(SCIVector3dArray*)newVector3dArray;
-initWithArray:(NSArray *)array;


-initWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithVector3d:(SCIVector3d*)vector count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithScalar:(NSNumber*)scalar count:(NSUInteger)count precision:(SCIVectorPrecision)precision;

-initWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ precision:(SCIVectorPrecision)precision;
-initWithXYZ:(SCIVector3dArray*)newXYZ precision:(SCIVectorPrecision)precision;
-initWithX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ precision:(SCIVectorPrecision)precision;
-initWithXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ precision:(SCIVectorPrecision)precision;

-initWithVector3dArray:(SCIVector3dArray*)newVector3dArray precision:(SCIVectorPrecision)precision;
-initWithArray:(NSArray *)array precision:(SCIVectorPrecision)precision;


-initWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithXYZ:(SCIVector3dArray*)newXYZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;

-initWithVector3dArray:(SCIVector3dArray*)newVector3dArray count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
-initWithArray:(NSArray *)array count:(NSUInteger)count precision:(SCIVectorPrecision)precision;



-initWithVector3dArray:(SCIVector3dArray*)newVector3dArray range:(NSRange)range;
-initWithVector3dArray:(SCIVector3dArray*)newVector3dArray indices:(SCINumberArray*)indices;

-initWithVector3dArray:(SCIVector3dArray*)newVector3dArray range:(NSRange)range precision:(SCIVectorPrecision)precision;
-initWithVector3dArray:(SCIVector3dArray*)newVector3dArray indices:(SCINumberArray*)indices precision:(SCIVectorPrecision)precision;


-initByMergingVector3dArrays:(NSArray*)vector3dArrays;
-initByMergingVector3dArrays:(NSArray*)vector3dArrays precision:(SCIVectorPrecision)precision;

#pragma mark Double Initializers:

-initWithXd:(double*)newXd Yd:(double*)newYd Zd:(double*)newZd count:(NSUInteger)count;

-initWithDouble:(double)scalar count:(NSUInteger)count;

#pragma mark Float Initializers:

-initWithXf:(float*)newXf Yf:(float*)newYf Zf:(float*)newZf count:(NSUInteger)count;

-initWithFloat:(float)scalar count:(NSUInteger)count;

#pragma mark Creators

+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ;
+(SCIVector3dArray*)vector3dArrayWithXYZ:(SCIVector3dArray*)newXYZ;
+(SCIVector3dArray*)vector3dArrayWithXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ;
+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ;

+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray;
+(SCIVector3dArray*)vector3dArrayWithArray:(NSArray *)array;

+(SCIVector3dArray*)vector3dArrayWithSize:(NSUInteger)count;
+(SCIVector3dArray*)vector3dArrayWithVector3d:(SCIVector3d*)vector count:(NSUInteger)count;
+(SCIVector3dArray*)vector3dArrayWithScalar:(NSNumber*)scalar count:(NSUInteger)count;


+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithXYZ:(SCIVector3dArray*)newXYZ precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ precision:(SCIVectorPrecision)precision;

+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithArray:(NSArray *)array precision:(SCIVectorPrecision)precision;

+(SCIVector3dArray*)vector3dArrayWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithVector3d:(SCIVector3d*)vector count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithScalar:(NSNumber*)scalar count:(NSUInteger)count precision:(SCIVectorPrecision)precision;



+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ count:(NSUInteger)count;
+(SCIVector3dArray*)vector3dArrayWithXYZ:(SCIVector3dArray*)newXYZ count:(NSUInteger)count;
+(SCIVector3dArray*)vector3dArrayWithXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ count:(NSUInteger)count;
+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ count:(NSUInteger)count;

+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray count:(NSUInteger)count;
+(SCIVector3dArray*)vector3dArrayWithArray:(NSArray *)array count:(NSUInteger)count;


+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithXYZ:(SCIVector3dArray*)newXYZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ count:(NSUInteger)count precision:(SCIVectorPrecision)precision;

+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray count:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithArray:(NSArray *)array count:(NSUInteger)count precision:(SCIVectorPrecision)precision;


+(SCIVector3dArray*)zerosWithSize:(NSUInteger)count;
+(SCIVector3dArray*)onesWithSize:(NSUInteger)count;

+(SCIVector3dArray*)zerosWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)onesWithSize:(NSUInteger)count precision:(SCIVectorPrecision)precision;


+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray range:(NSRange)range;
+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray indices:(SCINumberArray*)indices;

+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray range:(NSRange)range precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithVector3dArray:(SCIVector3dArray*)newVector3dArray indices:(SCINumberArray*)indices precision:(SCIVectorPrecision)precision;



+(SCIVector3dArray*)vector3dArrayByMergingVector3dArrays:(NSArray*)vector3Arrays;	
+(SCIVector3dArray*)vector3dArrayByMergingVector3dArrays:(NSArray*)vector3dArrays precision:(SCIVectorPrecision)precision;


#pragma mark Double Creators:

+(SCIVector3dArray*)vector3dArrayWithXd:(double*)newXd Yd:(double*)newYd Zd:(double*)newZd count:(NSUInteger)count;


+(SCIVector3dArray*)zerosDoubleWithSize:(NSUInteger)count;
+(SCIVector3dArray*)onesDoubleWithSize:(NSUInteger)count;

+(SCIVector3dArray*)vector3dArrayWithDouble:(double)scalar count:(NSUInteger)count;

#pragma mark Float Creators:

+(SCIVector3dArray*)vector3dArrayWithXf:(float*)newXf Yf:(float*)newYf Zf:(float*)newZf count:(NSUInteger)count;

+(SCIVector3dArray*)zerosFloatsWithSize:(NSUInteger)count;
+(SCIVector3dArray*)onesFloatsWithSize:(NSUInteger)count;

+(SCIVector3dArray*)vector3dArrayWithFloat:(float)scalar count:(NSUInteger)count;

#pragma mark Get accessors

-(SCIVector3d*)vectorAtIndex:(NSUInteger)index;


-(SCINumberArray*)x; 
-(SCINumberArray*)y;
-(SCINumberArray*)z;

-(SCIVector2dArray*)xx;
-(SCIVector2dArray*)yy;
-(SCIVector2dArray*)zz;

-(SCIVector2dArray*)xy;
-(SCIVector2dArray*)yx;

-(SCIVector2dArray*)xz;
-(SCIVector2dArray*)zx;

-(SCIVector2dArray*)yz;
-(SCIVector2dArray*)zy;


-(SCIVector3dArray*)xxx;
-(SCIVector3dArray*)xyy;
-(SCIVector3dArray*)xzz;

-(SCIVector3dArray*)xxy;
-(SCIVector3dArray*)xyx;

-(SCIVector3dArray*)xxz;
-(SCIVector3dArray*)xzx;

-(SCIVector3dArray*)xyz;
-(SCIVector3dArray*)xzy;


-(SCIVector3dArray*)yxx;
-(SCIVector3dArray*)yyy;
-(SCIVector3dArray*)yzz;

-(SCIVector3dArray*)yxy;
-(SCIVector3dArray*)yyx;

-(SCIVector3dArray*)yxz;
-(SCIVector3dArray*)yzx;

-(SCIVector3dArray*)yyz;
-(SCIVector3dArray*)yzy;


-(SCIVector3dArray*)zxx;
-(SCIVector3dArray*)zyy;
-(SCIVector3dArray*)zzz;

-(SCIVector3dArray*)zxy;
-(SCIVector3dArray*)zyx;

-(SCIVector3dArray*)zxz;
-(SCIVector3dArray*)zzx;

-(SCIVector3dArray*)zyz;
-(SCIVector3dArray*)zzy; 

#pragma mark Set accessors
-(void)setVector:(SCIVector3d*)vector atIndex:(NSUInteger)index;
-(void)setXYZ:(SCIVector3dArray*)newXYZ;
-(void)setX:(SCINumberArray*)newX;
-(void)setY:(SCINumberArray*)newY;
-(void)setZ:(SCINumberArray*)newZ;
-(void)setXY:(SCIVector2dArray*)newXY Z:(SCINumberArray*)newZ;
-(void)setX:(SCINumberArray*)newX YZ:(SCIVector2dArray*)newYZ;
-(void)setX:(SCINumberArray*)newX Y:(SCINumberArray*)newY Z:(SCINumberArray*)newZ; 



#pragma mark Operations
-(SCINumberArray *)magnitude;
-(SCINumberArray *)squaredMagnitude;
-(SCINumberArray *)argument;

-(SCIVector3dArray *)versor;
-(SCIVector3dArray *)negative;
-(SCIVector3dArray *)absolute;

-(SCIVector3dArray *)add:(SCIVector3dArray *)vector;
-(SCIVector3dArray *)sub:(SCIVector3dArray *)vector;
-(SCIVector3dArray *)mul:(SCIVector3dArray *)vector;
-(SCIVector3dArray *)div:(SCIVector3dArray *)vector;

-(SCIVector3dArray *)addScalar:(SCINumberArray *)numberArray;
-(SCIVector3dArray *)subScalar:(SCINumberArray *)numberArray;
-(SCIVector3dArray *)mulScalar:(SCINumberArray *)numberArray;
-(SCIVector3dArray *)divScalar:(SCINumberArray *)numberArray;

//-(SCINumberArray *)dot:(SCIVector3dArray *)vector;
// FIXME: "implementar depois de SCIVector3dArray"
//-(SCIVector3dArray *)cross:(SCIVector3dArray *);


#pragma mark SelfOperations
-(SCIVector3dArray *)normalize; //selfVersor
-(SCIVector3dArray *)negate; //selfNegative
-(SCIVector3dArray *)selfAbsolute;

-(SCIVector3dArray *)selfAdd:(SCIVector3dArray *)vector;
-(SCIVector3dArray *)selfSub:(SCIVector3dArray *)vector;
-(SCIVector3dArray *)selfMul:(SCIVector3dArray *)vector;
-(SCIVector3dArray *)selfDiv:(SCIVector3dArray *)vector;

-(SCIVector3dArray *)selfAddScalar:(SCINumberArray *)numberArray;
-(SCIVector3dArray *)selfSubScalar:(SCINumberArray *)numberArray;
-(SCIVector3dArray *)selfMulScalar:(SCINumberArray *)numberArray;
-(SCIVector3dArray *)selfDivScalar:(SCINumberArray *)numberArray;

// FIXME: "implementar futuramente"
//-(SCIVector3dArray *)selfDot:(SCIVector3dArray *)vector;


#pragma mark ArrayExtras
-(SCIVector3d *)sumVector;
-(SCIVector3d *)averageVector;


-(SCIVector3d *)magnitudeSumVector;
-(SCIVector3d *)absoluteSumVector;

#pragma mark Optimization Code:

-(BOOL)optimizeForCalculations;

-(BOOL)isOptimizedForCalculations;
-(BOOL)clearOptimizationForCalculations;
-(void*)pointerForX;
-(void*)pointerForY;
-(void*)pointerForZ;

-(void*)vectorizedPointerForX;
-(void*)vectorizedPointerForY;
-(void*)vectorizedPointerForZ;

-(void)replaceObject:(id)object atIndex:(NSInteger)index;


#pragma mark StringMethods
-initWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator;
-initWithString:(NSString*)numberString separator:(NSString*)separator precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString precision:(SCIVectorPrecision)precision;
-initWithString:(NSString*)numberString separator:(NSString*)separator;
-initWithString:(NSString*)numberString;

+(SCIVector3dArray *)vector3dArrayWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray *)vector3dArrayWithString:(NSString*)numberString vectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator;
+(SCIVector3dArray *)vector3dArrayWithString:(NSString*)numberString separator:(NSString*)separator precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray *)vector3dArrayWithString:(NSString*)numberString precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray *)vector3dArrayWithString:(NSString*)numberString separator:(NSString*)separator;
+(SCIVector3dArray *)vector3dArrayWithString:(NSString*)numberString;



-(NSString*) stringValue;
-(NSString*) stringValueWithVectorSeparator:(NSString*)vectorSeparator elementsSeparator:(NSString*)elementsSeparator;
-(NSString*) stringValueWithSeparator:(NSString*)separator;


#pragma mark FileMethods
-initWithContentsOfFile:(NSString *)path;
-initWithContentsOfURL:(NSURL *)aURL;
-initWithContentsOfFile:(NSString *)path precision:(SCIVectorPrecision)precision;
-initWithContentsOfURL:(NSURL *)aURL precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithContentsOfFile:(NSString *)path precision:(SCIVectorPrecision)precision;
+(SCIVector3dArray*)vector3dArrayWithContentsOfURL:(NSURL *)aURL precision:(SCIVectorPrecision)precision;
-(BOOL)writeToFile:(NSString *)path atomically:(BOOL)flag;
-(BOOL)writeToURL:(NSURL *)aURL atomically:(BOOL)flag;


@end

#pragma mark -
@interface SCIVector3dArray (SCIVector3dArrayPrimitiveAdditions)
#pragma mark Double Methods Additions:
#pragma mark Double get accessors

-(SCIVector3d*)doubleVectorAtIndex:(NSUInteger)index;

-(double*)xd; 
-(double*)yd;
-(double*)zd;

#pragma mark Double set accessors

-(void)setXd:(double*)newXd;
-(void)setYd:(double*)newYd;
-(void)setZd:(double*)newZd;
-(void)setXd:(double*)newXd Yd:(double*)newYd Zd:(double*)newZd;


#pragma mark Float Methods Additions:
#pragma mark Float get accessors

-(SCIVector3d*)floatVectorAtIndex:(NSUInteger)index;

-(float*)xfv; 
-(float*)yfv;
-(float*)zfv;
 
#pragma mark Float set accessors
-(void)setXf:(float*)newXf;
-(void)setYf:(float*)newYf;
-(void)setZf:(float*)newZf;
-(void)setXf:(float*)newXf Yf:(float*)newYf Zf:(float*)newZf;



#pragma mark Double Operations
-(double)doubleMagnitude;
-(double)doubleSquaredMagnitude;
-(double)doubleArgument;

-(SCIVector3dArray *)addDouble:(double)doubleNumber;
-(SCIVector3dArray *)subDouble:(double)doubleNumber;
-(SCIVector3dArray *)mulDouble:(double)doubleNumber;
-(SCIVector3dArray *)divDouble:(double)doubleNumber;


#pragma mark Double SelfOperations
-(SCIVector3dArray *)selfAddDouble:(double)doubleNumber;
-(SCIVector3dArray *)selfSubDouble:(double)doubleNumber;
-(SCIVector3dArray *)selfMulDouble:(double)doubleNumber;
-(SCIVector3dArray *)selfDivDouble:(double)doubleNumber;

#pragma mark Float Operations
-(float)floatMagnitude;
-(float)floatSquaredMagnitude;
-(float)floatArgument;

-(SCIVector3dArray *)addFloat:(float)floatNumber;
-(SCIVector3dArray *)subFloat:(float)floatNumber;
-(SCIVector3dArray *)mulFloat:(float)floatNumber;
-(SCIVector3dArray *)divFloat:(float)floatNumber;


#pragma mark Float SelfOperations

-(SCIVector3dArray *)selfAddFloat:(float)floatNumber;
-(SCIVector3dArray *)selfSubFloat:(float)floatNumber;
-(SCIVector3dArray *)selfMulFloat:(float)floatNumber;
-(SCIVector3dArray *)selfDivFloat:(float)floatNumber;


@end
